import React, { useState } from "react";
import logo from "./logo.svg";
import "./App.css";

interface GreeterProps {
  name: string;
  setName: (name: string) => void;
}

const Greeter: React.FC<GreeterProps> = ({ name, setName }) => {
  return (
    <div>
      {name.length ? <>Hello </> : <>What is your name? </>}
      <input
        autoComplete="off"
        className="border-b focus:border-lime-400 border-gray-50 focus:outline-none text-center bg-transparent"
        autoFocus
        type="text"
        style={{
          width: Math.max(100, 10 * name.length) + "px",
        }}
        value={name}
        onChange={(e) => setName(e.target.value)}
      />
    </div>
  );
};

function App() {
  const [count, setCount] = useState(0);
  const [name, setName] = useState("");
  return (
    <div className="bg-sky-800 bg-opacity-80 text-white flex flex-col items-center justify-center h-screen">
      <img
        src={logo}
        className="w-[300px] animate-spin"
        alt="logo"
        style={{
          animationDuration: `${20 / (name.length || 1)}s`,
        }}
      />
      <div className="text-center">
        <p className="text-3xl">Hello Vite + React!</p>
        <p>
          <button
            className="text-xl shadow hover:shadow-md transition-all bg-lime-500 bg-opacity-70 hover:bg-lime-600 p-2 rounded m-2"
            type="button"
            onClick={() => setCount((count) => count + 1)}
          >
            count is: {count}
          </button>
        </p>
        <Greeter name={name} setName={setName} />
      </div>
    </div>
  );
}

export default App;
